<?php

/**
 * vi:set sw=4 ts=4 noexpandtab fileencoding=utf-8:
 * @class  innopayController
 * @author infinisoft(sales@infinisoft.co.kr)
 * @brief  innopayController
 */
class innopayController extends innopay
{
	function init()
	{

		// set template path
		if($this->module_info->module != 'innopay')
		{
			$this->module_info->skin = 'default';
		}
		if(!$this->module_info->skin)
		{
			$this->module_info->skin = 'default';
		}
		$this->setTemplatePath($this->module_path . "skins/{$this->module_info->skin}");

		Context::set('module_info', $this->module_info);
	}

    function procInnopayReturn()
    {
        $payArgs = new Object(0, $utf8ResultMsg);
        $oEpayController = getController('epay');
        $oInnopayModel = getModel('innopay');

        $res_cd = Context::get('ResultCode');
        $payment_method = Context::get('PayMethod');

        $payArgs->add('transaction_srl', Context::get('MallReserved'));
		$payArgs->add('payment_method', $oInnopayModel->getEpayCode(Context::get('PayMethod')));
		$payArgs->add('payment_amount', Context::get('Amt'));
		$payArgs->add('result_code', '0000');
		$payArgs->add('result_message', '성공');
		$payArgs->add('pg_tid', Context::get('TID'));

        if($payment_method == 'CARD'){
            if($res_cd == '3001')
            {
                $payArgs->add('state', constant('STATE_COMPLETED'));
            }else{
                $payArgs->add('state', constant('STATE_FAILURE'));
            }
        }

        if($payment_method == 'BANK'){
            if($res_cd == '4000')
            {
                $payArgs->add('state', constant('STATE_COMPLETED'));
            }else{
                $payArgs->add('state', constant('STATE_FAILURE'));
            }
        }

        if($payment_method == 'VBANK'){
            if($res_cd == '4100')
            {
                $payArgs->add('state', constant('STATE_NOTCOMPLETED'));

                $payArgs->add('vact_bankname', Context::get('VbankName'));      // 은행명
                $payArgs->add('vact_num', Context::get('VbankNum'));            // 계좌번호
                $payArgs->add('vact_name', Context::get('VBankAccountName'));   // 예금주
                $payArgs->add('vact_date', Context::get('VbankExpDate'));       // 송금일자
                $payArgs->add('vact_time', '');                                 // 송금시간
                $payArgs->add('vact_inputname', '');                            // 송금자명

            }else{
                $payArgs->add('state', constant('STATE_FAILURE'));
            }
        }

        $output = $oEpayController->afterPayment($payArgs);
		if(!$output->toBool())
		{
			return $output;
		}

        $return_url = $output->get('return_url');
		//$this->setRedirectUrl($return_url);
        echo "<script>";
        echo "    if(opener){ opener.location.href='".$return_url."'; this.close(); }";
        echo "    if(!opener){ location.href='".$return_url."'; this.close(); }";
        echo "</script>";
    }

    function procInnopayNotiReturn()
    {

        $order_srl = Context::get('moid');
        $pay_method = Context::get('payMethod');
        $status = Context::get('status');

        //승인
        if($status == '25'){
            $oEpayModel = getModel('epay');
            $oInnopayModel = getModel('innopay');

            $transaction_info = $oEpayModel->getTransactionByOrderSrl($order_srl);
            if(!$transaction_info)
            {
                return new Object(-1, 'could not find transaction');
            }

            $innopayHome = sprintf(_XE_PATH_ . "files/epay/innopay");
            $TEMP_IP = $_SERVER["REMOTE_ADDR"];
            $PG_IP = substr($TEMP_IP, 0, 11);

            //PG에서 보냈는지 IP로 체크
            if($PG_IP != "211.236.243")
            {
                //return new Object(-1, 'msg_invalid_request');
            }

            $logfile = fopen($innopayHome . "/log/innopay_noti_" . date("Ymd") . ".log", "a+");
            fwrite($logfile, "************************************************\n");
            $vars = Context::getRequestVars();
            foreach($vars as $key => $val)
            {
                fwrite($logfile, $key . " : " . $val . "\n");
            }
            fwrite($logfile, "************************************************\n\n");
            fclose($logfile);

            $output = new Object();
            $output->order_srl = Context::get('moid');
            $output->amount = Context::get('goodsAmt');

            if($output->amount == $transaction_info->payment_amount)
            {
                $output->add('state', constant('STATE_COMPLETED')); // successfully completed
                $output->add('result_code', '0000');
                $output->add('result_message', '성공');
            }
            else
            {
                $output->setError(-1);
                $output->setMessage('amount does not match');
                $output->add('state', constant('STATE_FAILURE')); // failed
                $output->add('result_code', '9999');
                $output->add('result_message', 'amount does not match');
            }

            $output->add('transaction_srl', $transaction_info->transaction_srl);
            $output->add('payment_method', $oInnopayModel->getInnopayNotiToEpayCode(Context::get('payMethod')));
            $output->add('payment_amount', $transaction_info->payment_amount);
            $output->add('pg_tid', $transaction_info->pg_tid);

            //가상계좌
            if($pay_method == "08"){
                $output->add('vact_bankname', $transaction_info->vact_bankname);
                $output->add('vact_num', $transaction_info->vact_num);
                $output->add('vact_name', $transaction_info->vact_name);
                $output->add('vact_inputname', $transaction_info->vact_inputname);
            }

            // doPayment will call an after trigger
            $oEpayController = getController('epay');
            $afterOutput = $oEpayController->afterPayment($output);
            if(!$afterOutput->toBool())
            {
                return $afterOutput;
            }

        }

		// 0000을 출력하고 끝내야 한다.
		echo "0000";
		exit(0);

    }

}
/* End of file innopay.controller.php */
/* Location: ./modules/innopay/innopay.controller.php */
