<?php

/**
 * @class  innopayModel
 * @author infinisoft(sales@infinisoft.co.kr)
 * @brief  innopayModel
 */
class innopayModel extends innopay
{
	/**
	 * @brief initialize this class
	 */
	function init()
	{
	}

	/**
	 * @brief return pg info.
	 */
	function triggerGetPgModules(&$pg_modules)
	{
		// get the module instance list
		$args->sort_index = "module_srl";
		$args->page = Context::get('page');
		$args->list_count = 100;
		$args->page_count = 10;
		$output = executeQueryArray('innopay.getModInstList', $args);
		if(!$output->toBool())
		{
			return $output;
		}
		$list = $output->data;
		if(!is_array($list))
		{
			$list = array();
		}
		foreach($list as $key => $val)
		{
			$pg_modules[$val->module_srl] = $val;
		}
	}

	/**
	 * @brief return payment methods info.
	 */
	function getPaymentMethods($module_srl)
	{
		if(!$module_srl)
		{
			return array();
		}
		$oModuleModel = getModel('module');
		$module_info = $oModuleModel->getModuleInfoByModuleSrl($module_srl);

		$list = array();


		if($module_info->method_creditcard == 'Y')
		{
			$modinfo = new stdClass();
			$modinfo->mid = $module_info->mid;
			$modinfo->module = 'innopay';
			$modinfo->act = 'dispInnopayForm';
			$modinfo->mode = 'submit';
			$modinfo->title = '신용카드';
			$modinfo->payment_method = 'CC';
			$modinfo->guide = $module_info->guide_creditcard;
			$list['innopay_creditcard'] = $modinfo;
		}
		if($module_info->method_directbank == 'Y')
		{
			$modinfo = new stdClass();
			$modinfo->mid = $module_info->mid;
			$modinfo->module = 'innopay';
			$modinfo->mode = 'submit';
			$modinfo->act = 'dispInnopayForm';
			$modinfo->title = '실시간계좌이체';
			$modinfo->payment_method = 'IB';
			$modinfo->guide = $module_info->guide_directbank;
			$list['innopay_banktransfer'] = $modinfo;
		}
		if($module_info->method_virtualaccount == 'Y')
		{
			$modinfo = new stdClass();
			$modinfo->mid = $module_info->mid;
			$modinfo->module = 'innopay';
			$modinfo->mode = 'submit';
			$modinfo->act = 'dispInnopayForm';
			$modinfo->title = '가상계좌';
			$modinfo->payment_method = 'VA';
			$modinfo->guide = $module_info->guide_virtualaccount;
			$list['innopay_virtualaccount'] = $modinfo;
		}
		if($module_info->method_mobilephone == 'Y')
		{
			$modinfo = new stdClass();
			$modinfo->mid = $module_info->mid;
			$modinfo->module = 'innopay';
			$modinfo->mode = 'submit';
			$modinfo->act = 'dispInnopayForm';
			$modinfo->title = '휴대폰';
			$modinfo->payment_method = 'MP';
			$modinfo->guide = $module_info->guide_mobilephone;
			$list['innopay_mobilephone'] = $modinfo;
		}

		return $list;
	}

	/**
	 * @brief translate epay code to innopay code
	 */
	function getInnopayCode($code)
	{
		$payment_method = "CARD";
		switch($code)
		{
			case "CC":
				$payment_method = "CARD";
				break;
			case "IB":
				$payment_method = "BANK";
				break;
			case "VA":
				$payment_method = "VBANK";
				break;
			default:
				$payment_method = "";
		}
		return $payment_method;
	}

	/**
	 * @brief translate innopay code to epay code
	 */
	function getEpayCode($code)
	{
		$payment_method = "CC";
		switch($code)
		{
			case "CARD":
				$payment_method = "CC";
				break;
			case "BANK":
				$payment_method = "IB";
				break;
			case "VBANK":
				$payment_method = "VA";
				break;
			default:
				$payment_method = "CC";
		}
		return $payment_method;
	}

    function getInnopayNotiToEpayCode($code)
	{
		$payment_method = "CC";
		switch($code)
		{
			case "0108":
				$payment_method = "CC";
				break;
			case "07":
				$payment_method = "IB";
				break;
			case "08":
				$payment_method = "VA";
				break;
			default:
				$payment_method = "CC";
		}
		return $payment_method;
	}
}
