<?php

/**
 * vi:set sw=4 ts=4 noexpandtab fileencoding=utf-8:
 * @class  innopayView
 * @author infinisoft(sales@infinisoft.co.kr)
 * @brief  innopayView
 */
class innopayView extends innopay
{
	/**
	 * @brief initialize this class
	 */
	function init()
	{
		// set template path
		if($this->module_info->module = 'innopay')
		{
			$this->module_info->skin = 'default';
		}
		if(!$this->module_info->skin)
		{
			$this->module_info->skin = 'default';
		}
		$this->setTemplatePath($this->module_path . "skins/{$this->module_info->skin}");
		if($this->module_info->innopay_payment_test_mode == 'Y')
		{
			$this->module_info->innopay_mid = "testpay02m";
			$this->module_info->innopay_merchant_key = "7ssh+gyiyKfcTcaf47dwnWMqs+XweygK3eGrGAQH6au7LgRNnMQLq7sAiwp82xz8nFyBl4BK+ppwy4ECQkODzA==";
		}
		Context::set('module_info', $this->module_info);
	}

	/**
	 * @brief epay.getPaymentForm 에서 호출됨
	 */
	function dispInnopayForm()
	{
		$oEpayController = getController('epay');
		$oNcartModel = getModel('ncart');

		$innopayhome = sprintf(_XE_PATH_ . "files/epay/%s", $this->module_info->module_srl);

		// get products info using cartnos
		$reviewOutput = $oEpayController->reviewOrder();
		if(!$reviewOutput->toBool())
		{
			return $reviewOutput;
		}
		Context::set('review_form', $reviewOutput->review_form);
		Context::set('item_name', $reviewOutput->item_name);
		Context::set('price', $reviewOutput->price);
		Context::set('transaction_srl', $reviewOutput->transaction_srl);
		Context::set('order_srl', $reviewOutput->order_srl);

		// payment method 변환 <-- CC, IB, VA, MP 를 결제모듈에서 정의된 것으로 대체할 수 있으면 좋겠음.
		$payment_method = Context::get('payment_method');
		switch($payment_method)
		{
			case "CC":
				$payment_method = "CARD";
				break;
			case "IB":
				$payment_method = "BANK";
				break;
			case "VA":
				$payment_method = "VBANK";
				break;
			default:
				$payment_method = "";
		}
		Context::set('payment_method', $payment_method);

        $logged_info = Context::get('logged_info');
        if($logged_info)
		{
			if(!$in_args->purchaser_name)
			{
				$in_args->purchaser_name = $logged_info->nick_name;
			}
			if(!$in_args->purchaser_email)
			{
				$in_args->purchaser_email = $logged_info->email_address;
			}
			if(!$in_args->purchaser_telnum)
			{
				$in_args->purchaser_telnum = "010-0000-0000";
			}
		}
		else if(!Context::get('is_logged'))
		{
			if(!$in_args->purchaser_name)
			{
				$in_args->purchaser_name = 'GUEST';
			}
			if(!$in_args->purchaser_email)
			{
				$in_args->purchaser_email = '';
			}
			if(!$in_args->purchaser_telnum)
			{
				$in_args->purchaser_telnum = "010-0000-0000";
			}
		}

		Context::set('purchaser_name', $in_args->purchaser_name);
		Context::set('purchaser_email', $in_args->purchaser_email);
		Context::set('purchaser_telnum', $in_args->purchaser_telnum);

		$this->setTemplateFile('pay');
	}
}
/* End of file innopay.view.php */
/* Location: ./modules/innopay/innopay.view.php */
